unit U_TfA;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Printers, StdCtrls;


type Turtle = class
        P_Turtle : TImage; 
        Fw, Fx, Fy : real;
 	      procedure WTurtleMod360;
	      procedure TurnTo (Angle: Real);
	      procedure Turn   (Angle: Real);
	      procedure MoveTo (x, y  : Real);
	      procedure Move   (Length: Real);
	      procedure DrawTo (x, y  : Real);
	      procedure Draw   (Length: Real);
	      procedure Clear;
	      procedure Init;
	      procedure SetColor(Farbe:TColor);
	      procedure SetBGColor(Farbe:TColor);
	      Procedure Verbinde(VAR P : TImage);
        published
	      procedure TurtleMouseUp(Sender: TObject;
  		        Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    end;

const PIdurch180 = 0.017453;


implementation

procedure Turtle.TurtleMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MoveTo(x,y);
  TurnTo(0);
  P_Turtle.Canvas.Pixels[x,y]:= clblack;
end;


procedure Turtle.WTurtleMod360;
begin
  while Fw >= 360 do Fw:= Fw - 360;
  while Fw <    0 do Fw:= Fw + 360;
end;

procedure Turtle.TurnTo (Angle: Real);
begin
  Fw:= Angle; WTurtleMod360;
end;

procedure Turtle.Turn   (Angle: Real);
begin
  Fw:= Fw + Angle; WTurtleMod360;
end;

procedure Turtle.MoveTo (x, y  : Real);
begin
  Fx:= x; Fy:= y;
end;

procedure Turtle.Move   (Length: Real);
begin
  Fx:= Fx + Length * Cos (Fw * PIdurch180);
  Fy:= Fy - Length * Sin (Fw * PIdurch180);
end;

procedure Turtle.DrawTo (x, y  : Real);
begin
  P_Turtle.Canvas.MoveTo(Round(Fx), Round(Fy));
  Fx:= x; Fy:= y;
  P_Turtle.Canvas.LineTo(Round(Fx), Round(Fy));
end;

procedure Turtle.Draw   (Length: Real);
begin
  DrawTo (Fx + Length * Cos (Fw * PIdurch180),
          Fy - Length * Sin (Fw * PIdurch180));
end;

procedure Turtle.Clear;
begin
 with P_Turtle do begin
  Canvas.FillRect(Rect(0, 0, Width, Height));
   fw:=0;
   fx:=P_Turtle.width div 2;
   fy:=P_Turtle.height div 2;
  end;
end;

procedure Turtle.Init;
begin
   clear;
   fw:=0;
   fx:=P_Turtle.width div 2;
   fy:=P_Turtle.height div 2;
end;

procedure Turtle.SetColor(Farbe:TColor);
begin
   P_Turtle.canvas.pen.color:=farbe;
end;

procedure Turtle.SetBGColor(Farbe:TColor);
begin
   with P_Turtle do begin
      Canvas.Brush.color:=farbe;
      Canvas.FillRect(Rect(0, 0, Width, Height));
      end;
end;

Procedure Turtle.Verbinde(VAR P : TImage);
begin
  P_Turtle := P;
Init;
end;

end.
